'-----------------------------------------------------------------------
' Using OLE DB: WASPDB.Chapter.Test.Embedded.vbs
' Copyright (c) 2003, Paradigm Corporation, All Rights Reserved.
'-----------------------------------------------------------------------
' This material may be freely used and distributed provided that the
' copyright notice above and this disclaimer are preserved in their
' entirety. This material is offered AS-IS WITH NO WARRANTY. Paradigm
' hereby disclaims all warranties respecting this material, expressed
' or implied, including without limitation warranty of design, merchant-
' ability, fitness for a particular purpose and against infringement.                                              '
'-----------------------------------------------------------------------
' ADO Chaptered Rowset Demonstration for DMSII Embedded data sets.
'
' Parameters:
'   (none)
'-----------------------------------------------------------------------
' Modification Log.
' 2002-09-11  P.Kimpel
'   Original version, cloned from WASPDB.Chapter.Test.Occurs.vbs.
' 2003-09-14  P.Kimpel
'   Adapt for Using OLE DB Demo site.
'-----------------------------------------------------------------------

Option Explicit

Const adOpenForwardOnly = 0
Const adLockReadOnly = 1
Const adCmdTableDirect = 512

Dim db
Dim fld
Dim fso
Dim inx
Dim rsLoc
Dim rs
Dim text
Dim tf

'---------------------------------------
Function Pic9n(byVal v, byVal chars)
  'Formats a numeric value "v" as a string of "chars" length with leading zeroes.
  Dim s
  Dim sz

  s = CStr(v)
  sz = Len(s)
  If sz > chars Then
    Pic9n = Right(s, chars)
  ElseIf sz < chars Then
    Pic9n = String(chars-sz, "0") & s
  Else
    Pic9n = s
  End If
End Function

'---------------------------------------
Function PicXn(byVal v, byVal chars)
  'Formats a string value "v" as left justified over spaces in a field "chars" long.
  Dim sz

  sz = Len(CStr(v))
  If sz < chars Then
    PicXn = v & Space(chars-sz)
  ElseIf sz > chars Then
    PicXn = Left(v, chars)
  Else
    PicXn = v
  End If
End Function

'---------------------------------------
Function PicZn(byVal v, byVal chars)
  'Formats a numeric value "v" as a string of "chars" length with leading spaces.
  Dim s
  Dim sz

  s = CStr(v)
  sz = Len(s)
  If sz > chars Then
    PicZn = Right(s, chars)
  ElseIf sz < chars Then
    PicZn = Space(chars-sz) & s
  Else
    PicZn = s
  End If
End Function

'---------------------------------------

'--- create and open the output text file ---
Set fso = WScript.CreateObject("Scripting.FileSystemObject")
Set tf = fso.CreateTextFile("WASPDB.Chapter.Test.Embedded.txt", True)

'--- create and open the ADO connection ---
Set db = WScript.CreateObject("ADODB.Connection")
db.Open "Provider=Unisys.DMSII;Data Source=WASPDB;"

'--- create and open the ADO recordset for CATALOG ---
Set rs = WScript.CreateObject("ADODB.Recordset")
rs.Open "CATALOG", db, adOpenForwardOnly, adLockReadOnly, adCmdTableDirect
rs.CacheSize = 50

'--- set up the report and column headings ---
text = "WASPDB Data Base CATALOG Embedded Recordset Test"
text = text & PicZn(FormatDateTime(Date, vbShortDate), 79-Len(text))
tf.WriteLine text
tf.WriteLine String(79, "-")

'--- loop through the CATALOG recordset ---
Do While Not rs.EOF
  tf.WriteBlankLines 1
  tf.WriteLine "CATALOG: " & rs("catalogid") & " - " & rs("uom")

  '--- LOCATIONX is an index to the embedded data set
  '--- The chapter acts like a Recordset object, so set an object reference to it and iterate its rows
  Set rsLoc = rs("LOCATIONX").Value
  inx = CLng(0)
  While Not rsLoc.EOF
    inx = inx + 1
    tf.Write Space(4) & PicZn(inx, 4) & ": "
    For Each fld in rsLoc.Fields
      tf.Write fld.Name & "=" & fld.Value & " "
    Next

    tf.WriteLine
    rsLoc.MoveNext
  Wend

  rsLoc.Close
  rs.MoveNext
Loop

'--- close the ADO objects and deallocate them ---
Set rsLoc = Nothing
rs.Close
Set rs = Nothing
db.Close
Set db = Nothing

'--- close the text file and deallocate the FSO objects ---
tf.WriteBlankLines 1
tf.WriteLine "End List"
tf.Close
Set tf = Nothing
Set fso = Nothing

MsgBox "CATALOG Report Completed"
