'-----------------------------------------------------------------------
' Using OLE DB WASPDB.ConnProperties.vbs
' Copyright (c) 2003, Paradigm Corporation, All Rights Reserved.
'-----------------------------------------------------------------------
' This material may be freely used and distributed provided that the
' copyright notice above and this disclaimer are preserved in their
' entirety. This material is offered AS-IS WITH NO WARRANTY. Paradigm
' hereby disclaims all warranties respecting this material, expressed
' or implied, including without limitation warranty of design, merchant-
' ability, fitness for a particular purpose and against infringement.                                              '
'-----------------------------------------------------------------------
' ADO script that opens a connection to a DMSII data base, then formats
' the connection properties and table schema to a text file.
'-----------------------------------------------------------------------
' Modification Log.
' 2003-09-14  P.Kimpel
'   Original version, from SchemaDump.asp version.
'-----------------------------------------------------------------------

Option Explicit

Const adSchemaTables = 20

Dim db, fld, fso, prop, rs, text, tf

Set fso = WScript.CreateObject("Scripting.FileSystemObject")
Set tf = fso.CreateTextFile("WASPDB.ConnProperties.txt", True)

Set db = WScript.CreateObject ("ADODB.Connection")
db.Open "Provider=Unisys.DMSII;Data Source=WASPDB;"

'--- List the ADO connection object properties ---
tf.WriteLine "Properties for " & db.DefaultDatabase & "  [" & FormatDateTime(Date, vbShortDate) & "]"
tf.WriteLine "  Attributes        " & db.Attributes
tf.WriteLine "  CommandTimeout    " & db.CommandTimeout
tf.WriteLine "  ConnectionString  " & db.ConnectionString
tf.WriteLine "  CursorLocation    " & db.CursorLocation
tf.WriteLine "  DefaultDatabase   " & db.DefaultDatabase
tf.WriteLine "  IsolationLevel    " & db.IsolationLevel
tf.WriteLine "  Mode              " & db.Mode
tf.WriteLine "  Provider          " & db.Provider
tf.WriteLine "  State             " & db.State
tf.WriteLine "  ADO Version       " & db.Version

'--- List the dynamic properties for the connection ---
tf.WriteBlankLines 1
tf.WriteLine "Dynamic Properties:"
For Each prop In db.Properties
  tf.WriteLine "  " & prop.Name & " = " & prop.Value
Next


'--- get the schema data for tables in the data base ---
tf.WriteBlankLines 1
tf.WriteLine "Tables in the Data Base (<catalog>.<schema>.<tablename>):"
tf.WriteBlankLines 1
Set rs = db.OpenSchema(adSchemaTables)
If rs.EOF Then
  tf.WriteLine "  No table schema data found in " & db.DefaultDatabase
Else
  While Not rs.EOF
    text = "  " & rs("TABLE_CATALOG") & "." & rs("TABLE_SCHEMA") & "." & rs("TABLE_NAME")
    If Len(text) <= 40 Then
      tf.Write text & Space(40 - Len(text))
    Else
      tf.WriteLine text
      tf.Write Space(40)
    End If

    tf.Write "(type: " & rs("TABLE_TYPE")
    text = rs("DATE_MODIFIED")
    If Not IsNull(text) Then
      tf.Write ", updated: " & FormatDateTime(text, vbShortDate)
    End If

    tf.Write ") "
    text = rs("DESCRIPTION")
    If Not IsNull(text) Then
      tf.Write text
    End If

    tf.WriteLine
    rs.MoveNext
  Wend
End If

rs.Close
Set rs = Nothing
db.Close
Set db = Nothing
tf.Close
Set tf = Nothing
