'-----------------------------------------------------------------------
' Using OLE DB: WASPDB.ProdCode.10.SQL.vbs
' Copyright (c) 2003, Paradigm Corporation, All Rights Reserved.
'-----------------------------------------------------------------------
' This material may be freely used and distributed provided that the
' copyright notice above and this disclaimer are preserved in their
' entirety. This material is offered AS-IS WITH NO WARRANTY. Paradigm
' hereby disclaims all warranties respecting this material, expressed
' or implied, including without limitation warranty of design, merchant-
' ability, fitness for a particular purpose and against infringement.                                              '
'-----------------------------------------------------------------------
' A program to list all of the SKUs in the WASPDB which have prodcode=10
' along with their SKUGroup name. Uses the SQL Server linked server.
'-----------------------------------------------------------------------
' Modification Log.
' 2003-09-14  P.Kimpel
'   Adapt for Using OLE DB Demo site.
'-----------------------------------------------------------------------


Option Explicit

Const adOpenForwardOnly = 0
Const adLockReadOnly = 1
Const adCmdText = 1

Dim db
Dim fso
Dim rs
Dim rssg
Dim text
Dim tf

'---------------------------------------
Function Pic9n(byVal v, byVal chars)
  'Formats a numeric value "v" as a string of "chars" length with leading zeroes.
  Dim s
  Dim sz

  s = CStr(v)
  sz = Len(s)
  If sz > chars Then
    Pic9n = Right(s, chars)
  ElseIf sz < chars Then
    Pic9n = String(chars-sz, "0") & s
  Else
    Pic9n = s
  End If
End Function

'---------------------------------------
Function PicXn(byVal v, byVal chars)
  'Formats a string value "v" as left justified over spaces in a field "chars" long.
  Dim sz

  sz = Len(CStr(v))
  If sz < chars Then
    PicXn = v & Space(chars-sz)
  ElseIf sz > chars Then
    PicXn = Left(v, chars)
  Else
    PicXn = v
  End If
End Function

'---------------------------------------
Function PicZn(byVal v, byVal chars)
  'Formats a numeric value "v" as a string of "chars" length with leading spaces.
  Dim s
  Dim sz

  s = CStr(v)
  sz = Len(s)
  If sz > chars Then
    PicZn = Right(s, chars)
  ElseIf sz < chars Then
    PicZn = Space(chars-sz) & s
  Else
    PicZn = s
  End If
End Function

'---------------------------------------

'--- create and open the output text file ---
Set fso = WScript.CreateObject("Scripting.FileSystemObject")
Set tf = fso.CreateTextFile("WASPDB.ProdCode.10.SQL.txt", True)

'--- create and open the ADO connection ---
Set db = WScript.CreateObject("ADODB.Connection")
db.Open "Provider=SQLOLEDB; Server=(local); User ID=sa; Password=;"

'--- create and open the ADO recordset for SKUs ---
Set rs = WScript.CreateObject("ADODB.Recordset")

text = "select w.*, g.skugroupname " & _
       "from WASPDB.WASPDB.WASPDB.SKUs w left outer join WASPDB.WASPDB.WASPDB.SKUGroupTbl g " & _
           "on w.skugroup = g.skugroup " & _
       "where w.prodcode = 10"

rs.Open text, db, adOpenForwardOnly, adLockReadOnly, adCmdText
rs.CacheSize = 50

'--- set up the report and column headings ---
text = "SKUs with ProdCode=10"
text = text & PicZn(FormatDateTime(Date, vbShortDate), 79-Len(text))
tf.WriteLine text
tf.WriteLine String(79, "-")
tf.WriteBlankLines 1
tf.WriteLine PicZn("SKU", 5) & "  " & PicXn("Description", 30) & "  " & _
             PicZn("Each", 4) & "  " & "SG" & "  " & PicXn("SKU Group Name", 30)
tf.WriteLine String(5, "-") & "  " & String(30, "-") & "  " & _
             String(4, "-") & "  " & String(2, "-") & "  " & String(30, "-")

'--- loop through the SKUs recordset, selecting the appropriate ones ---
While Not rs.EOF
  If IsNull(rs("skugroupname")) Then
    text = "(unknown SKU Group)"
  Else
    text = rs("skugroupname")
  End If

  tf.WriteLine Pic9n(rs("sku"), 5) & "  " & PicXn(rs("container"), 30) & "  " & _
               PicZn(rs("skueach"), 4) & "  " & _
               Pic9n(rs("skugroup"), 2) & "  " & PicXn(text, 30)
  rs.MoveNext
Wend

'--- close the ADO objects and deallocate them ---
rs.Close
Set rs = Nothing
db.Close
Set db = Nothing

'--- close the text file and deallocate the FSO objects ---
tf.WriteBlankLines 1
tf.WriteLine "End List"
tf.Close
Set tf = Nothing
Set fso = Nothing

MsgBox "Report Completed"
