'
'-----------------------------------------------------------------------
' Using OLE DB: WASPDB.SKUs.Add.vbs
' Copyright (c) 2003, Paradigm Corporation, All Rights Reserved.
'-----------------------------------------------------------------------
' This material may be freely used and distributed provided that the
' copyright notice above and this disclaimer are preserved in their
' entirety. This material is offered AS-IS WITH NO WARRANTY. Paradigm
' hereby disclaims all warranties respecting this material, expressed
' or implied, including without limitation warranty of design, merchant-
' ability, fitness for a particular purpose and against infringement.                                              '
'-----------------------------------------------------------------------
' A program to add a new record to the SKUs table.
'-----------------------------------------------------------------------
' Modification Log.
' 2003-09-14  P.Kimpel
'   Adapt for Using OLE DB Demo site.
'-----------------------------------------------------------------------

Option Explicit

Const adOpenForwardOnly = 0
Const adOpenDynamic = 2
Const adLockReadOnly = 1
Const adLockPessimistic = 2
Const adLockOptimistic = 3
Const adCmdTableDirect = 512

Const skuNr = 99008

Dim db
Dim rs
Dim rssg
Dim text

'------------------------------------------
Function CheckADOError(byVal conn, byRef msg)
  'Checks for errors in the connection Errors collection. If an error has occurred,
  'formats the error message(s) into "msg". Returns True if an error occurred.
  Dim e
  Dim result

  result = False
  msg = ""
  If conn.Errors.Count > 0 Then
    For each e in conn.Errors
      If e.Number < 0 Then
        result = True
        msg = msg & e.Number & ": " & e.Description & "." & vbCrLf
      End If
    Next
    conn.Errors.Clear
  End If

  CheckADOError = result
End Function

'---------------------------------------

'--- create and open the ADO connection ---
Set db = WScript.CreateObject("ADODB.Connection")
db.Open "Provider=Unisys.DMSII;Data Source=WASPDB;"
If CheckADOError(db, text) Then
  MsgBox "Error opening ADO connection." & vbCrLf & text
End If

'--- create and open the ADO recordset for SKUs ---
Set rs = WScript.CreateObject("ADODB.Recordset")
rs.Open "SKUs", db, adOpenDynamic, adLockOptimistic, adCmdTableDirect
If CheckADOError(db, text) Then
  MsgBox "Error opening ADO recordset." & vbCrLf & text
End If

On Error Resume Next

rs.AddNew Array("sku", "itemnum", "skugroup", "prodcode", "container", "skueach"), _
          Array(skunr,     10308,         91,         10, "TEST ITEM",        12)

'An alternate way to add the record:
    'rs.AddNew
    'rs("sku") = skuNr
    'rs("itemnum") = 10308
    'rs("skugroup") = 91
    'rs("prodcode") = 10
    'rs("container") = "TEST ITEM"
    'rs("skueach") = 12
    'rs.Update

If CheckADOError(db, text) Then
  MsgBox "Error adding SKU " & skuNr & "." & vbCrLf & text, vbCritical, "Alert!"
Else
  MsgBox "SKU "& skuNr & " added OK",, "Success"
End If

'--- close the ADO objects and deallocate them ---
rs.Close
Set rs = Nothing
db.Close
Set db = Nothing
