'-----------------------------------------------------------------------
' Using OLE DB: WASPDB.SKUs.Modify.vbs
' Copyright (c) 2003, Paradigm Corporation, All Rights Reserved.
'-----------------------------------------------------------------------
' This material may be freely used and distributed provided that the
' copyright notice above and this disclaimer are preserved in their
' entirety. This material is offered AS-IS WITH NO WARRANTY. Paradigm
' hereby disclaims all warranties respecting this material, expressed
' or implied, including without limitation warranty of design, merchant-
' ability, fitness for a particular purpose and against infringement.                                              '
'-----------------------------------------------------------------------
' A contrived script to update the SKUs table. Only records with skugroup=91
' are affected. If the sku is even, the record is deleted. If the sku is odd,
' the skugroup field is changed to 37.
'-----------------------------------------------------------------------
' Modification Log.
' 2003-09-14  P.Kimpel
'   Adapt for Using OLE DB Demo site.
'-----------------------------------------------------------------------

Option Explicit

Const adOpenForwardOnly = 0
Const adOpenDynamic = 2

Const adLockReadOnly = 1
Const adLockPessimistic = 2
Const adLockOptimistic = 3

Const adCmdTableDirect = 512

Const adStateClosed = 0
Const adStateOpen = 1

Dim db
Dim rs
Dim skuNr
Dim text

Dim skuf
Dim skuGroupf

'------------------------------------------
Function CheckADOError(byVal conn, byRef msg)
  'Checks for errors in the connection Errors collection. If an error has occurred,
  'formats the error message(s) into "msg" and returns True.
  Dim e
  Dim result

  result = False
  msg = ""
  If conn.Errors.Count > 0 Then
    For each e in conn.Errors
      If e.Number < 0 Then
        result = True
        msg = msg & e.Number & ": " & e.Description & "." & vbCrLf
      End If
    Next
    If result Then
      msg = msg & "ADO ver=" & db.Version
    End If
    conn.Errors.Clear
  End If

  CheckADOError = result
End Function

'---------------------------------------

'--- create and open the ADO connection ---
Set db = WScript.CreateObject("ADODB.Connection")
db.Open "Provider=Unisys.DMSII;Data Source=WASPDB;"
If db.State <> adStateOpen Then
  If CheckADOError(db, text) Then
    MsgBox "Error opening ADO connection." & vbCrLf & text
  End If
End If

'--- create and open the ADO recordset for SKUs ---
Set rs = WScript.CreateObject("ADODB.Recordset")
rs.Open "SKUs", db, adOpenDynamic, adLockOptimistic, adCmdTableDirect
If rs.State <> adStateOpen Then
  If CheckADOError(db, text) Then
    MsgBox "Error opening ADO recordset." & vbCrLf & text
  End If
End If

db.Errors.Clear
Set skuf = rs("sku")
Set skuGroupf = rs("skugroup")

'--- loop through the recordset, checking and updating as necessary ---
While Not rs.EOF
  skuNr = CLng(skuf)
  If CInt(skuGroupf) = 91 Then
    If (skuNr and 1) = 0 Then   'test for even
      rs.Delete
      If CheckADOError(db, text) Then
        MsgBox "SKU " & skuNr & " delete failed." & vbCrLf & text
      Else
        MsgBox "SKU " & skuNr & " deleted"
      End If
    Else
      skuGroupf.Value = 37
      rs.Update
      If CheckADOError(db, text) Then
        MsgBox "SKU " & skuNr & " update failed." & vbCrLf & text
      Else
        MsgBox "SKU " & skuNr & " skugroup updated"
      End If
    End If
  End If
  rs.MoveNext
Wend

'--- close the ADO objects and deallocate them ---
Set skuGroupf = Nothing
Set skuf = Nothing
rs.Close
Set rs = Nothing
db.Close
Set db = Nothing

MsgBox "Update completed."
