'-----------------------------------------------------------------------
' Using OLE DB: WASPDB.TerritoryList.vbs
' Copyright (c) 2003, Paradigm Corporation, All Rights Reserved.
'-----------------------------------------------------------------------
' This material may be freely used and distributed provided that the
' copyright notice above and this disclaimer are preserved in their
' entirety. This material is offered AS-IS WITH NO WARRANTY. Paradigm
' hereby disclaims all warranties respecting this material, expressed
' or implied, including without limitation warranty of design, merchant-
' ability, fitness for a particular purpose and against infringement.                                              '
'-----------------------------------------------------------------------
' A program to list all of the Territories (sales staff) in WASPDB.
' Opens the connection using a UDL (Uniform Data Locator) file.
'-----------------------------------------------------------------------
' Modification Log.
' 2003-09-14  P.Kimpel
'   Adapt for Using OLE DB Demo site.
'-----------------------------------------------------------------------

Option Explicit

Dim db                  'ADO connection object reference
Dim fld                 'ADO field object reference
Dim fso                 'Scripting.FileSystemObject reference
Dim rs                  'ADO recordset object reference
Dim text                'Scratch string for formatting output
Dim tf                  'FileSystemObject text file object reference

'--- create and open the output text file ---
Set fso = WScript.CreateObject("Scripting.FileSystemObject")
Set tf = fso.CreateTextFile("WASPDB.TerritoryList.txt", True)

'--- create and open the ADO connection ---
Set db = WScript.CreateObject("ADODB.Connection")
db.Open "File Name=..\WASPDB.udl;" 'User name/password is in the UDL file

'--- create and open the ADO recordset for Territories ---
Set rs = WScript.CreateObject("ADODB.Recordset")
rs.Open "TerrTbl", db           'Let the CursorType, LockType, and Options
                                'params use default values

'--- loop through the recordset, extracting the data ---
While Not rs.EOF
  'Note: the Value property returns a field's value, but
  'since it's the default property, it can be omitted.
  text = rs("territory").Value  & ", " & _
         rs("region")           & ", " & _
         rs("territoryname")
  tf.WriteLine text
  rs.MoveNext
Wend

'--- close the ADO objects and deallocate them ---
rs.Close
Set rs = Nothing
db.Close
Set db = Nothing

'--- close the text file and deallocate the FSO objects ---
tf.Close
Set tf = Nothing
Set fso = Nothing

MsgBox "Territory List Completed"
