<%@ LANGUAGE=VBScript%>
<!-- #include virtual="/UNITE2003/Scripts/WASPutil.inc" -->
<%

'-----------------------------------------------------------------------
' Using OLE DB: CustomerNameQuery-Direct.asp
' Copyright (c) 2003, Paradigm Corporation, All Rights Reserved.
'-----------------------------------------------------------------------
' This material may be freely used and distributed provided that the
' copyright notice above and this disclaimer are preserved in their
' entirety. This material is offered AS-IS WITH NO WARRANTY. Paradigm
' hereby disclaims all warranties respecting this material, expressed
' or implied, including without limitation warranty of design, merchant-
' ability, fitness for a particular purpose and against infringement.                                              '
'-----------------------------------------------------------------------
' Customer name query results page.
' Session variables:
'   (none)
' Query string:
'   QP = original query page virtual path
'   Qtype = query type for the query page (SKU, Terr)
'   NameMethod : (byPrefix, byContains)
'   NamePrefix : text
'   NameContains : text
'-----------------------------------------------------------------------
' Modification Log.
' 2000-07-19  P.Kimpel
'   Original version.
' 2000-08-25  P.Kimpel
'   Implement normalization of name key for queries; add ship city/st/zip.
' 2000-09-09  P.Kimpel
'   Implement intenal anchor for and link to "Tips".
' 2000-09-13  P.Kimpel
'   Implement links for script pathing and standardized appearance.
' 2001-05-09  P.Kimpel
'   Modifications for Innatrack interface.
' 2001-05-19  P.Kimpel
'   Implement style sheets and new formatting.
' 2001-06-01  P.Kimpel
'   Trim leading spaces from shipNo, billTo, keyCode, and territory codes.
' 2001-06-14  P.Kimpel
'   Add trade class column.
' 2003-09-17  P.Kimpel
'   Adapt for Using OLE DB Demo site.
'-----------------------------------------------------------------------

Const title = "Customers by Name -- Direct Table Version"
Const maxRecords = 200

Dim conn
Dim rs
Dim SQLstring
Dim codeType
Dim code
Dim records
Dim byPrefix

Dim fShipNo
Dim fName
Dim fCity
Dim fState
Dim fZip
Dim fBillTo
Dim fKeyCode
Dim fTerritory
Dim fTradeClass
Dim fAlpha

'---------------------------------------
Function NormalizeName (ByVal Raw)
  Dim x, y, top
  Dim norm, char, suffix

  If Len(Trim(raw)) = 0 Then
    NormalizeName = "<nothing>"
  Else
    norm = ""
    suffix = ""
    top = Len(raw)
    x = 1
    y = 1
    While x <= top
      char = Mid(raw, x, 1)
      If Not (InStr (1, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789", char) > 0) Then
        If x > y Then
          norm = norm & Mid(raw, y, x-y)
        End If
        y = x+1
        If char = "*" Then
          suffix = suffix & norm
          norm = ""
        End If
      End If
      x = x+1
    Wend

    If x > y then
      norm = norm & Mid(raw, y, x-y)
    End If

    NormalizeName = UCase(norm & suffix)
  End If
End Function


'---------------------------------------
Sub FormatRow(byVal shipNo, byVal name, byVal city, byVal state, byVal zip, byVal billTo, byVal keyCode, byVal territory, byVal tradeClass)
  'Formats one row of customer data

  %>
    <tr class=data>
    <td class=number><a href="/UNITE2003/Scripts/CustomerQuery-Direct.asp?ShipNo=<%= shipNo
          %>&amp;QP=<%=Request.QueryString("QP")
          %>&amp;Qtype=<%=Request.QueryString("Qtype")
          %>"><%= shipNo
        %></a>
    <td class=data>
      <%= name %>
    <td class=data><%= CellText(city) & " " & state %>
    <td class=data><%= CellText(zip) %>
    <td class=center><%
      If shipNo = billTo or CStr(billTo) = "0" Then
        Response.Write "&nbsp;"
      Else
        Response.Write CellText(billTo)
      End If
      %>
    <td class=center><%
      If Len(Trim(keyCode)) > 0 Then
        Response.Write keyCode
      Else
        Response.Write "&nbsp;"
      End If
      %>
    <td class=center><%= CellText(territory) %>
    <td class=center><%= CellText(tradeClass) %>
    <%
End Sub

'---------------------------------------

Response.Buffer = True
FormatHTMLHeading title
FormatWASPHeading title
Response.Flush
Server.ScriptTimeout = 600
%>

<table border=0 cellspacing=0 cellpadding=2 width="100%">
<tr>
<td align=left>Customers with names
<%

codeType = Request.QueryString("NameMethod")
If codeType = "byPrefix" Then
  byPrefix = True
  code = NormalizeName(Request.QueryString("NamePrefix"))
  Response.Write "beginning with <tt><b>" & code & "</b></tt>..."
  SQLstring = "SHIPALPHA LIKE '" & code & "%'"
Else
  byPrefix = False
  code = NormalizeName(Request.QueryString("NameContains"))
  Response.Write "containing ...<tt><b>" & code & "</b></tt>..."
  SQLstring = "SHIPALPHA LIKE '%" & code & "%'"
End If

Set conn = Server.CreateObject ("ADODB.Connection")
conn.Open Application("WASPconn")
conn.CommandTimeout = 300

Set rs = Server.CreateObject("ADODB.Recordset")
records = CLng(0)

rs.Open "ARMASTER", conn, adOpenForwardOnly, adLockReadOnly, adCmdTableDirect
rs.Index = "ARMASTERSHIPALPHA"
rs.CacheSize = 50
If byPrefix Then
  rs.Seek code, adSeekAfterEQ
Else
  rs.Find SQLstring, 0, adSearchForward, adBookmarkFirst
End If

If rs.EOF Then
  Response.Write "</table><p class=error>No matching names</p>"
Else
  Set fShipNo = rs("SHIPNO")
  Set fName = rs("SHIPNAME")
  Set fCity = rs("SHIPCITY")
  Set fState = rs("SHIPST")
  Set fZip = rs("SHIPZIP")
  Set fBillTo = rs("BILLNO")
  Set fKeyCode = rs("KEYCODE")
  Set fTerritory = rs("TERRITORY")
  Set fTradeClass = rs("TRADECL")
  Set fAlpha = rs("SHIPALPHA")
  %>
  <td align=right><a href="#Tips">Tips</a>
  </table>

  <table border=1 cellspacing=0 cellpadding=2>
  <thead>
  <tr valign=bottom>
    <th>Ship No
    <th>Customer
    <th>City
    <th>ZIP
    <th>Bill To
    <th>Key Code
    <th>Territory
    <th>Trade Class
  </thead>
  <%

  Response.Flush
  Do While Not rs.EOF
    If byPrefix Then
      If Left(fAlpha, Len(code)) <> code Then
        Exit Do
      End If
    End If

    FormatRow Trim(fShipNo.Value), fName.Value, fCity.Value, fState.Value, fZip.Value, _
        Trim(fBillTo.Value), Trim(fKeyCode.Value), Trim(fTerritory.Value), Trim(fTradeClass.Value)
    records = records + 1
    If records >= maxRecords Then
      Exit Do
    Else
      If byPrefix Then
        rs.MoveNext
      Else
        rs.Find SQLstring, 1, adSearchForward, adBookmarkCurrent
      End If
      If records mod 20 = 0 Then
        Response.Flush
      End If
    End If
  Loop

  Response.Write "</table>"
  Response.Flush

  If records >= maxRecords Then
    Response.Write "<p class=error>Query halted after " & records & " records<p>"
  End If
  %>
  <a name="Tips"></a><b>Tips:</b>
  <ul>
    <li>Click a <b>Ship No</b> to show details for that customer.
  </ul>
  <%
End If

Set fShipNo = Nothing
Set fName = Nothing
Set fCity = Nothing
Set fState = Nothing
Set fZip = Nothing
Set fBillTo = Nothing
Set fKeyCode = Nothing
Set fTerritory = Nothing
Set fTradeClass = Nothing
Set fAlpha = Nothing

rs.Close
Set rs = Nothing
conn.Close
Set conn = Nothing
%>
<p>
<table border=0 cellspacing=0 cellpadding=2 width="100%">
<tr valign=bottom>
  <td align=left><a href="CustomerNameRequest-Direct.asp?QP=<%=Request.QueryString("QP")
      %>&amp;Qtype=<%=Request.QueryString("Qtype")
      %>">New Query</a>
  <td align=right nowrap>
      <a href="/UNITE2003/Default.htm">Home</a>
</table>
</body>
</html>
