<%@ LANGUAGE=VBScript%>
<!-- #include virtual="/UNITE2003/Scripts/WASPutil.inc" -->
<%
'-----------------------------------------------------------------------
' Using OLE DB: Generic-SchemaDump.asp
' Copyright (c) 2003, Paradigm Corporation, All Rights Reserved.
'-----------------------------------------------------------------------
' This material may be freely used and distributed provided that the
' copyright notice above and this disclaimer are preserved in their
' entirety. This material is offered AS-IS WITH NO WARRANTY. Paradigm
' hereby disclaims all warranties respecting this material, expressed
' or implied, including without limitation warranty of design, merchant-
' ability, fitness for a particular purpose and against infringement.                                              '
'-----------------------------------------------------------------------
' Generalized data base schema display demonstration.
' This script will display a list of tables for any OLE DB data source.
' To use, enter a valid OLE DB connection string in the text box on the
' page, or pass a connection string with the ConnString parameter.
'
' Examples:
'   For Microsoft SQL Server:
'       "Provider=SQLOLEDB; Host=(local); Database=master; UID=user; PWD=password;"
'   For Microsoft Jet 4.0 (Access 2000 .mdb files):
'       "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=C:\DBdir\Mydb.mdb"
'   For Generic ODBC Data Sources:
'       "Provider=MSDASQL.1; Data Source=MyODBCsource;"
'   For Unisys MCP OLE DB:
'       "Provider=Unisys.DMSII; Data Source=mydb;" or
'       "Provider=Unisys.DMSII; Database=(OUR)TESTDB on TESTPACK; User=DEV;
'               Password=SECRET; Host=devsys.ourcorp.com; Port=1871;"
'
' This script generates links for a companion script, Generic-TableDump.asp.
' Clicking on one of these links will display the detailed schema for
' the selected table and a sample of the table's data.
'
' Session variables:
'   (none)
' Query string:
'   ConnString
'-----------------------------------------------------------------------
' Modification Log.
' 2001-05-17  P.Kimpel
'   Original version, from OLE DB SchemaDump.asp as a base.
' 2001-05-30  P.Kimpel
'   Implement styles; misc formatting changes.
' 2001-07-09  P.Kimpel
'   Modify for /VISION/Scripts/SecretProgrammer directory.
' 2002-03-19  P.Kimpel
'   Modify for OLEDB/VB class WASPDB data base.
' 2002-04-12  P.Kimpel
'   Pass schema and table name parameters separately.
' 2003-09-14  P.Kimpel
'   Adapt for Using OLE DB Demo site.
'-----------------------------------------------------------------------

Const title = "ADO Generic Schema Display"

Dim connString
Dim db
Dim dbErr
Dim oops
Dim rs
Dim text
Dim fatalError

Response.Buffer = True
FormatHTMLHeading title
FormatWASPHeading title

fatalError = False
connString = Trim(Request.Form("ConnString"))

%>
<form method=post action="<%= Request.ServerVariables("SCRIPT_NAME") %>">
  <b>ADO Connection String:</b><br>
  <input name=ConnString type=text size=80 value="<%= Server.HTMLEncode(connString) %>">
  <input name=Submit type=submit value="Open">
</form>
<%

If Len(connString) = 0 Then
  Response.End
End If

Response.Flush
Set db = Server.CreateObject ("ADODB.Connection")
On Error Resume Next
db.Open connString
Set dbErr = db.Errors
If dbErr.Count > 0 Then
  Response.Write "<p><b>Errors:</b><ul>"
  For Each oops in dbErr
    Response.Write "<li>" & oops.Number & ": " & oops.Description
    If oops.Number > 0 Then
      fatalError = True
    End If
  Next
  Response.Write "</ul></body></html>"
  Response.Flush
  If fatalError Then
    Response.End
  End If
End If

If Not fatalError Then
  Response.Write "<p><b>ADO connection opened to:</b><br><tt>" & _
                 Server.HTMLEncode(db.ConnectionString) & "</tt>"
  Response.Flush

  Set rs = db.OpenSchema(adSchemaTables)

  If rs.BOF Then
    Response.Write "<p><span class=error><b>No database schema data found</b></span>"
  Else %>
    <p>
    <table border=1 cellspacing=0 cellpadding=3>
      <th>Catalog
      <th>Schema
      <th>Table Name
      <th>Table Type
      <th>Description
      <th>Last Modified
    <%
    While Not rs.EOF %>
      <tr>
        <td class=data>
            <%= rs("TABLE_CATALOG") %>
        <td class=data>
            <%= rs("TABLE_SCHEMA") %>
        <td class=data>
            <a href="Generic-TableDump.asp?Catalog=<%= Server.HTMLEncode(rs("TABLE_CATALOG") & "&Schema=" & rs("TABLE_SCHEMA") & "&Table=" & rs("TABLE_NAME") & "&ConnString=" & connString)%>">
                <%= rs("TABLE_NAME") %></a>
        <td class=data><%= rs("TABLE_TYPE") %>
        <td class=data><%
          text = rs("DESCRIPTION")
          If IsNull(text) Then
            Response.Write "n/a"
          Else
            Response.Write text
          End If %>
        <td class=number><%
          text = rs("DATE_MODIFIED")
          If IsNull(text) Then
            Response.Write "n/a"
          Else
            Response.Write FormatDateTime(text, vbShortDate)
          End If
          %>
      <%
      rs.MoveNext
    Wend

    Response.Write "</table>"
  End If

  rs.Close
  Set rs = Nothing
End If

db.Close
Set db = Nothing
%>

<div align=right>
    <a href="/UNITE2003/Default.htm">Home</a>
</div>
</body>
</html>
