<%@ LANGUAGE=VBScript%>
<!-- #include virtual="/UNITE2003/Scripts/WASPutil.inc" -->
<%

'-----------------------------------------------------------------------
' Using OLE DB: Generic-TableDump.asp
' Copyright (c) 2003, Paradigm Corporation, All Rights Reserved.
'-----------------------------------------------------------------------
' This material may be freely used and distributed provided that the
' copyright notice above and this disclaimer are preserved in their
' entirety. This material is offered AS-IS WITH NO WARRANTY. Paradigm
' hereby disclaims all warranties respecting this material, expressed
' or implied, including without limitation warranty of design, merchant-
' ability, fitness for a particular purpose and against infringement.                                              '
'-----------------------------------------------------------------------
' Generic database table display.
' This script will display the schema for a single table from an OLE DB
' data source. If there is data in the table, up to the first eight
' rows are displayed. It is designed to be used with the Generic-SchemaDump.asp
' script, but can be used independently by passing the data source
' connection string, catalog name, schema name, and table name as query
' string parameters.
'
' Session variables:
'   (none)
' Query string:
'   ConnString
'   Catalog
'   Schema
'   Table
'-----------------------------------------------------------------------
' Modification Log.
' 2001-05-17  P.Kimpel
'   Original version.
' 2001-05-30  P.Kimpel
'   Add FormatIndex subroutine to display table index schema.
' 2001-11-19  P.Kimpel
'   Replace with clone from InnaTrackTableDump.asp to show data snapshots.
' 2001-12-27  P.Kimpel
'   Reinstate formatting table structure from schema data as an alternative to a
'   recordset when the table contains no rows.
' 2002-01-07  P.Kimpel
'   Highlight table name prefix in field names.
' 2002-03-19  P.Kimpel
'   Modify for OLEDB/VB class WASPDB data base.
' 2002-04-12  P.Kimpel
'   Receive schema and table name parameters separately.
' 2003-09-14  P.Kimpel
'   Adapt for Using OLE DB Demo site.
'-----------------------------------------------------------------------

Const title = "ADO Generic Table Display"

Const maxRecords = 8                    'max sample rows to display
Const adArrayFlag = &H2000
Const typeBinary = 128

Dim connString
Dim db
Dim rs
Dim catalogName
Dim schemaName
Dim tableName
Dim msg
Dim types

'---------------------------------------
Sub BuildTypes
  'Loads the "types" dictionary object with ADO type code/description pairs.

  Set types = Server.CreateObject("Scripting.Dictionary")
  types.add CStr(     0), "Empty"
  types.add CStr(     1), "Null"
  types.add CStr(     2), "Integer"
  types.add CStr(     3), "Long"
  types.add CStr(     4), "Single"
  types.add CStr(     5), "Double"
  types.add CStr(     6), "Currency"
  types.add CStr(     7), "Date"
  types.add CStr(     8), "BSTR"
  types.add CStr(     9), "COM-IDispatch"
  types.add CStr(    10), "Error"
  types.add CStr(    11), "Boolean"
  types.add CStr(    12), "Variant"
  types.add CStr(    13), "COM-IUnknown"
  types.add CStr(    14), "Decimal"
  types.add CStr(    16), "S-Byte"
  types.add CStr(    17), "U-Byte"
  types.add CStr(    18), "U-Integer"
  types.add CStr(    19), "U-Long"
  types.add CStr(    20), "BigInt"
  types.add CStr(    21), "U-BigInt"
  types.add CStr(    64), "FileTime"
  types.add CStr(    72), "GUID"
  types.add CStr(   128), "Binary"
  types.add CStr(   129), "Char"
  types.add CStr(   130), "WChar"
  types.add CStr(   131), "Numeric"
  types.add CStr(   132), "UserDefined"
  types.add CStr(   133), "DBdate"
  types.add CStr(   134), "DBtime"
  types.add CStr(   135), "DBtimestamp"
  types.add CStr(   136), "Chapter"
  types.add CStr(   138), "PropVariant"
  types.add CStr(   139), "VarNumeric"
  types.add CStr(   200), "VarChar"
  types.add CStr(   201), "LongVarChar"
  types.add CStr(   202), "VarWChar"
  types.add CStr(   203), "LongVarWChar"
  types.add CStr(   204), "VarBinary"
  types.add CStr(   205), "LongVarBinary"
  types.add CStr(&H1000), "Vector"
  types.add CStr(&H2000), "Array"
  types.add CStr(&H8000), "Reserved"
End Sub

'---------------------------------------
Function FormatFieldName(byVal fieldName)
  'Formats the name of a field by highlighting the 4-character table name prefix.

  '>>If Len(fieldName) > 4 Then
  '>>  FormatFieldName = "<del>" & Left(fieldName, 4) & "</del>" & Mid(fieldName, 5)
  '>>Else
    FormatFieldName = fieldName
  '>>End If
End Function

'---------------------------------------
Function FormatType(byVal fieldType, byVal definedSize, byVal precision, byVal scale)
  'Formats the Type property for an ADO field.
  Dim key
  Dim s

  s = ""

  If (fieldType and adArrayFlag) <> 0 Then
    s = s & "Array: "
    fieldType = (fieldType and Not adArrayFlag)
  End If

  key = CStr(fieldType)
  If types.Exists(key) Then
    s = s & types.Item(key)
  Else
    s = s & "Unknown[" & key & "]"
  End If

  s = s & "("
  If Not IsNull(definedSize) Then
    s = s & definedSize
    If Not IsNull(precision) Then
      If precision > 0 and precision < 255 Then
        s = s & ":"
      End If
    End If
  End If

  If Not IsNull(precision) Then
    If precision > 0 and precision < 255 Then
      s = s & precision
      If scale > 0 and scale < 255 Then
        s = s & "." & scale
      End If
    End If
  End If

  FormatType = s & ")"
End Function

'---------------------------------------
Sub FormatIndexes(byVal catalogName, byVal schemaName, byVal tableName)
  'Formats the indexes for the table referenced by 'catalogName.schemaName.tableName'
  Dim done
  Dim rs
  Dim fName
  Dim iType
  Dim lastName
  Dim pKey

  Set rs = db.OpenSchema(adSchemaIndexes, Array(catalogName, schemaName, Empty, Empty, tableName))
  If rs.BOF Then
    Response.Write "<p><span class=error><b>No indexes for this table</b></span>"
  Else %>
    <p><b>Indexes:</b>
    <table border=1 cellspacing=0 cellpadding=3>
      <tr>
      <th>Index Name
      <th>Type
      <th>Primary
      <th>Unique
      <th>Fields
      <%
    Set fName = rs("INDEX_NAME")
    Do
      lastName = fName.Value
      Response.Write "<tr valign=top><td class=data>" & lastName

      Response.Write "<td class=data>"
      iType = rs("TYPE")
      Select Case iType
        Case 1
          Response.Write "B+tree"
        Case 2
          Response.Write "Hash"
        Case 3
          Response.Write "Content"
        Case 4
          Response.Write "Other"
        Case Else
          Response.Write "(" & CStr(iType) & ")"
      End Select

      pKey = rs("PRIMARY_KEY")
      Response.Write "<td class=data>"
      If IsNull(pKey) Then
        Response.Write "&nbsp;"
      Else
        Response.Write pKey
      End If
      Response.Write "<td class=data>" & rs("UNIQUE")
      Response.Write "<td class=data>"
      done = False
      Do
        Response.Write rs("ORDINAL_POSITION") & ": " & FormatFieldName(rs("COLUMN_NAME"))
        If rs("COLLATION") <> 1 Then
          Response.Write " (descending)"
        End If
        Response.Write "<br>"
        rs.MoveNext
        If rs.EOF Then
          done = True
        ElseIf fName.Value <> lastName Then
          done = True
        End If
      Loop Until done
      Response.Write vbCrLf
    Loop Until rs.EOF
    Response.Write "</table>" & vbCrLf
  End If

  Set fName = Nothing
  rs.Close
  Set rs = Nothing
End Sub

'---------------------------------------
Sub FormatTableSchema(byVal catalogname, byVal schemaName, byVal tablename)
  'Formats the columns for a table from ADO schema data.
  Dim schema

  Set schema = db.OpenSchema(adSchemaColumns, Array(catalogName, schemaName, tableName))
  If schema.EOF Then
    Response.Write "<p class=error><b>No table schema data found</b></p>"
  Else
    Response.Write "<p><b>Fields:</b>"
    Response.Write "<table border=1 cellspacing=0 cellpadding=2>"
    Response.Write "<tr><th>Field<th>Type"
    Do
      Response.Write "<tr><td class=data>" & FormatFieldName(schema("COLUMN_NAME"))
      Response.Write "<td class=data>" & FormatType(schema("DATA_TYPE"), _
          schema("CHARACTER_MAXIMUM_LENGTH"), schema("NUMERIC_PRECISION"), _
          schema("NUMERIC_SCALE")) & vbCrLf
      schema.MoveNext
    Loop Until schema.EOF

    Response.Write "</table>" & vbCrLf
  End If

  schema.Close
  Set schema = Nothing
End Sub

'---------------------------------------
Sub FormatTableData(byVal rs)
  'Formats the columns and a set of sample rows for a table from an ADO recordset.
  Dim bl, bv, bx
  Dim fld
  Dim nrCols
  Dim nrRows
  Dim rows
  Dim text
  Dim x, y

  Response.Write "<p><b>Fields:</b>"
  Response.Write "<table border=1 cellspacing=0 cellpadding=2>"
  Response.Write "<tr valign=bottom><th>Field<th>Type"

  rows = rs.GetRows(maxRecords)
  nrRows = UBound(rows, 2)
  nrCols = UBound(rows, 1)

  For x = 0 to nrRows
    Response.Write "<th>Row " & x+1
  Next

  For y = 0 to nrCols
    Set fld = rs(y)
    Response.Write "<tr valign=top><td class=data>" & FormatFieldName(fld.Name)
    Response.Write "<td class=data>" & FormatType(fld.Type, fld.DefinedSize, fld.Precision, fld.NumericScale)
    For x = 0 to nrRows
      If IsNull(rows(y,x)) Then
        text = "&lt;null&gt;"
          ElseIf fld.Type = typeBinary Then
            text = "Hex: "
                bl = fld.DefinedSize
                For bx = 1 to bl
                  bv = AscB(MidB(rows(y,x), bx, 1))
                  If bv < 16 Then
                    text = text & "0"
                  End If
                  text = text & Hex(bv)
                  If bx Mod 4 = 0 Then
                    text = text & " "
                  End If
                Next
      Else
        text = CStr(rows(y,x))
        If Len(Trim(text)) = 0 Then
          text = "&nbsp;"
        End If
      End If
      Response.Write "<td class=data>" & text
    Next
  Next

  Response.Write "</table>"

  Set fld = Nothing
End Sub

'---------------------------------------
Function OpenTable(byVal tableName, byVal rs, byRef msg)
  'Opens the named table. If there is no error, and the table contains data,
  'returns False; otherwise returns True and formats an HTML message in msg.
  Dim dbErr
  Dim oops
  Dim result

  result = False
  msg = ""
  On Error Resume Next

  rs.Open tableName, db, adOpenForwardOnly, adLockReadOnly, adCmdTableDirect

  Set dbErr = db.Errors
  If dbErr.Count > 0 Then
    msg = msg & "<p><span class=error>Open Errors:</span>" & _
        "<ul style=""list-style-image:url(/UNITE2003/Images/bangdesk.gif)"">"
    For Each oops in dbErr
      msg = msg & "<li>" & oops.Number & ": " & oops.Description
      If oops.Number < 0 Then
        result = True
      End If
    Next
    msg = msg & "</ul>"
  End If

  If Not result Then
    If rs.EOF Then
      result = True
      msg = msg & "<p class=error>Table has no data -- showing schema only</p>"
      rs.Close
    End If
  End If

  Set dbErr = Nothing
  Set oops = Nothing
  OpenTable = result
End Function

'---------------------------------------

Response.Buffer = True
FormatHTMLHeading title
FormatWASPHeading title
BuildTypes

connString = Trim(Request.QueryString("ConnString"))
catalogName = Request.QueryString("Catalog")
schemaName = Request.QueryString("Schema")
tableName = Request.QueryString("Table")

Response.Write "<table border=0 cellspacing=0 cellpadding=0>"
Response.Write "<tr><td><b>Connection:</b>&nbsp;<td class=data>" & Server.HTMLEncode(connString)
Response.Write "<tr><td><b>Table:</b>&nbsp;<td class=data>" & catalogname & "." & schemaName & "." & tableName
Response.Write "</table>"
Response.Flush

Set db = Server.CreateObject ("ADODB.Connection")
db.Open connString

Set rs = Server.CreateObject("ADODB.RecordSet")
If OpenTable(catalogName & "." & schemaName & "." & tableName, rs, msg) Then
  If Len(msg) > 0 Then
    Response.Write msg
  Else
    Response.Write "<p class=error>Table has no data -- showing schema only</p>"
  End If
  FormatTableSchema catalogName, schemaName, tablename
Else
  FormatTableData(rs)
  rs.Close
End If

Set rs = Nothing

FormatIndexes catalogName, schemaName, tableName

db.Close
Set db = Nothing
Set types = Nothing
%>

<div align=right>
    <a href="javascript:history.back();">Back</a>&nbsp;&nbsp;&nbsp;
    <a href="/UNITE2003/Default.htm">Home</a>
</div>
</body>
</html>
