<%
'-----------------------------------------------------------------------
' Using OLE DB: WASPutil.inc
' Copyright (c) 2003, Paradigm Corporation, All Rights Reserved.
'-----------------------------------------------------------------------
' This material may be freely used and distributed provided that the
' copyright notice above and this disclaimer are preserved in their
' entirety. This material is offered AS-IS WITH NO WARRANTY. Paradigm
' hereby disclaims all warranties respecting this material, expressed
' or implied, including without limitation warranty of design, merchant-
' ability, fitness for a particular purpose and against infringement.                                              '
'-----------------------------------------------------------------------
' General utility routines include file.
'-----------------------------------------------------------------------
' Modification Log.
' 2001-05-19  P.Kimpel
'   Original version, from bits and pieces of existing pages.
' 2003-09-14  P.Kimpel
'   Adapt for Using OLE DB Demo site.
'-----------------------------------------------------------------------

Option Explicit

'---------------------------------------
Function CellText(byVal text)
  'Formats the text for a cell, returning "&nbsp;" for a null or empty value.
  Dim s

  If IsNull(text) Then
    s = "&nbsp;"
  Else
    s = Trim(Cstr(text))
    If Len(s) = 0 Then
      s = "&nbsp;"
    End If
  End If

  CellText = s
End Function

'---------------------------------------
Sub FormatHTMLHeading(byVal title)
  'Formats the standard HTML page heading for WASP pages

  Response.Expires = 30                 'minutes
  %>
<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
  <title>Using OLE DB -- <%= title %></title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
  <meta name="Author" content="Paul Kimpel, Paradigm Corp.">
  <link rel=stylesheet type="text/css" href="/UNITE2003/Scripts/WASP.css">

  <%
End Sub

'---------------------------------------
Sub FormatWASPHeading(byVal title)
  'Ends the HTML heading and formats the WASP page heading

  %>
</head>

<body>
<table border=0 cellspacing=0 cellpadding=2 width="100%">
  <tr valign=bottom>
    <td align=left><span class=larger><b>Using OLE DB &middot; <%= title %></b></span>
    <td class=number><%= FormatDateTime(Date(), vbShortDate) & " - " & FormatDateTime(Time(), vbShortTime) %>
</table>
<hr size=1 noshade>
  <%
End Sub

'---------------------------------------
Function PadLeft(byVal s, byVal chars)
  'Formats the string "s" to be exactly "chars" characters long, padding
  'with spaces or truncating on the left, as necessary.
  Dim sLen

  sLen = Len(s)
  If sLen < chars Then
    PadLeft = Space(chars - sLen) & s
  ElseIf sLen > chars Then
    PadLeft = Right(s, chars)
  Else
    PadLeft = s
  End If
End Function

'---------------------------------------
Function ISOtoDate(byVal ISOdate)
  'Converts an ISO 8601 date (yyyymmdd) in long integer form to a standard
  'VBScript date variant

  ISOtoDate = DateSerial(ISOdate\10000, (ISOdate\100) mod 100, ISOdate mod 100)
End Function

'---------------------------------------
Function DatetoISO(byVal vbDate)
  'Converts a VBScript date to an integer in ISO 8601 format (yyyymmdd).

  DatetoISO = (Year(d)*100 + Month(d))*100 + Day(d)
End Function

'---------------------------------------
Function Pic9n(byVal v, byVal chars)
  'Formats a numeric value "v" as a string of "chars" length with leading zeroes.
  Dim s
  Dim sz

  s = CStr(v)
  sz = Len(s)
  If sz > chars Then
    Pic9n = Right(s, chars)
  ElseIf sz < chars Then
    Pic9n = String(chars-sz, "0") & s
  Else
    Pic9n = s
  End If
End Function

'---------------------------------------
Function PicZn(byVal v, byVal chars)
  'Formats a numeric value "v" as a string of "chars" length with leading spaces.
  Dim s
  Dim sz

  s = CStr(v)
  sz = Len(s)
  If sz > chars Then
    PicZn = Right(s, chars)
  ElseIf sz < chars Then
    PicZn = Space(chars-sz) & s
  Else
    PicZn = s
  End If
End Function
'---------------------------------------
%>